#ifndef NET_ICMP_H
#define NET_ICMP_H

#include <types.h>
#include "ipv4.h"

#pragma pack(push, 1)
struct icmp_head_t {
    uint8 type;
    uint8 code;
    uint16 cs;
    uint32 hdata;
};

struct icmp_packet_t {
    struct icmp_head_t head;
#define ICMP_PAYLOD_MAX_SIZE 64 /* XXX */
    uint8 payload[ICMP_PAYLOD_MAX_SIZE];
};
#pragma pack(pop)

int icmp_process(struct icmp_packet_t *icmp, int len);


#endif

