#ifndef NET_DEF_H
#define NET_DEF_H

#include <types.h>
#include "../eth_def.h"

#pragma pack(push, 1)

#define HADDR_LEN    6

struct net_eth_frame_head_t {
    uint8 mac_dst[HADDR_LEN];
    uint8 mac_src[HADDR_LEN];
#define NET_ETHERTYPE_ARP    0x0806
#define NET_ETHERTYPE_IPV4   0x0800
    uint16 ethertype;
};

struct net_eth_frame_t {
    struct net_eth_frame_head_t head;
#define MAX_PAYLOAD_SIZE     (EMAC_BLOCK_SIZE - sizeof(struct net_eth_frame_head_t))
    uint8 payload[MAX_PAYLOAD_SIZE];
};
#pragma pack(pop)

struct net_info_t {
    uint8  haddr[HADDR_LEN];  /* mac address */
    uint32 paddr;    /* IPv4 protocol address */ 
    uint32 pmask;    /* IPv4 network mask (for broadcast support) */
};

extern struct net_info_t net_info;

uint16 NET_HTONS(uint16 n16);
uint32 NET_HTONL(uint32 n32);

#endif

