#ifndef NET_UDP_H
#define NET_UDP_H

#include <types.h>
#include "ipv4.h"

#pragma pack(push, 1)
struct udp_packet_head_t {
    uint16 src_port;
    uint16 dst_port;
    uint16 length;
    uint16 cs;
};

struct udp_packet_t {
    struct udp_packet_head_t head;
#define UDP_MAX_PAYLOAD_SIZE   65507 /* XXX */
    uint8 payload[UDP_MAX_PAYLOAD_SIZE];
};

///* pseudo packet for UDP framework */
//struct udp_packet2_t {
//    uint32 src_ip;
//    uint32 dst_ip;
//    uint16 src_port;
//    uint16 dst_port;
//    uint16 length;
//#define UDP_MAX_PAYLOAD_SIZE2 1500 /* XXX */
//    uint8 payload[UDP_MAX_PAYLOAD_SIZE2];
//};
#pragma pack(pop)

int udp_process(struct ipv4_packet_t *ipv4);
uint16 udp_cs(struct ipv4_packet_t *ipv4);

#endif

