/* 
 *     This file is part of K11, hardware multimedia player.
 * 
 * Copyright (C) 2014 Dmitry Kobylin
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <LPC177x_8x.h>
#include <LPC177x_8x_bits.h>
#include <debug.h>
#include "nvram.h"

struct nvram_store_t nvram;

/*
 *
 */
void nvram_load()
{
    nvram.reg[0] = LPC_RTC->GPREG0;
    nvram.reg[1] = LPC_RTC->GPREG1;
    nvram.reg[2] = LPC_RTC->GPREG2;
    nvram.reg[3] = LPC_RTC->GPREG3;
    nvram.reg[4] = LPC_RTC->GPREG4;
}

/*
 *
 */
void nvram_save()
{
    /* NOTE value for dport not spoiled by this save */
    LPC_RTC->GPREG1 = nvram.reg[1];
    LPC_RTC->GPREG2 = nvram.reg[2];
    LPC_RTC->GPREG3 = nvram.reg[3];
    LPC_RTC->GPREG4 = nvram.reg[4];
}

